/*
 * cleaner.h
 *
 *  Created on: 05.02.2011
 *      Author: ed
 */

#ifndef CLEANER_H_
#define CLEANER_H_

#include "lockable.h"
#include <ctime>
#include <limits>

/**
 * @brief Primitive task scheduler for internal helper functions
 *
 * It's based on few assumptions: a) called methods are static,
 * b) called method return the next time they want to be called
 * c) called method can be run at any time without side-effects
 * (they have to check the need of their internal work by themselves)
 */
class cleaner : public condition
{
public:
	cleaner();
	virtual ~cleaner();
	void RunLatestAt(time_t when);

	void WorkLoop();
	void Stop();

private:
	time_t m_hint; // -1: terminate ASAP
	pthread_t m_thr;
};

extern cleaner g_victor; // ... down to the nap

#endif /* CLEANER_H_ */
